unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,QRDecode, ExtCtrls,jpeg, ExtDlgs, Menus, ComCtrls, Spin,
  Clipbrd;
type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    ImageReadBtn: TButton;
    AnalyBtn: TButton;
    Label11: TLabel;
    SpinEdit3: TSpinEdit;
    SpinEdit1: TSpinEdit;
    Label8: TLabel;
    Label10: TLabel;
    SpinEdit2: TSpinEdit;
    ResultMemo: TMemo;
    Image1: TImage;
    MessMemo: TMemo;
    Bevel1: TBevel;
    QRDecode1: TQRDecode;
    Edit1: TEdit;
    Button1: TButton;
    procedure AnalyBtnClick(Sender: TObject);
    procedure ImageReadBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
  public
    SourceBitmap : TBitmap;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  SourceBitmap:=TBitmap.Create;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Edit1.Text:=QRDecode1.SerialNo;
  AnalyBtn.Enabled:=false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SourceBitmap.Free;
end;

procedure TForm1.AnalyBtnClick(Sender: TObject);
var
  state : boolean;
begin
  ResultMemo.Clear;
  MessMemo.Clear;
  // pX[h̐ݒ肪KvłB
  // CZX̂w肢܂B
  QRDecode1.Password:='*********************';
  QRDecode1.Resolver:=SpinEdit1.Value;
  QRDecode1.ForceVersion:=SpinEdit2.Value;
  QRDecode1.Warp:=SpinEdit3.Value;
  state:=QRDecode1.LoadBitmap(SourceBitmap);
  ResultMemo.Lines.Add(QRDecode1.datastring);
  if state then MessMemo.Lines.Add('')
           else MessMemo.Lines.Add('s');
  ResultMemo.Lines.Add(QRDecode1.ErrorStatus);
  ImageReadBtn.Enabled:=true;
end;

procedure TForm1.ImageReadBtnClick(Sender: TObject);
var
  JPG     : TJpegImage;
  ext     : string;
begin
  AnalyBtn.Enabled:=false;
  if OpenDialog1.Execute = false then exit;
  ext:=AnsiLowerCase(ExtractFileExt(OpenDialog1.FileName));
  if ( ext = '.jpg'  ) or
     ( ext = '.jpeg' ) then
    begin
      JPG := TJpegImage.Create;
      try
        JPG.Smoothing:=true;
        JPG.Performance:=jpBestQuality;
        JPG.LoadFromFile(OpenDialog1.FileName);
        SourceBitmap.Height:=JPG.Height;
        SourceBitmap.Width :=JPG.Width;
        SourceBitmap.Assign(JPG);
      finally
        JPG.free;
      end;
    end
  else
  if ( ext = '.bmp'  ) then
    begin
      SourceBitmap.LoadFromFile(OpenDialog1.FileName);
    end;
  Image1.Picture.Bitmap.Assign(SourceBitmap);
  AnalyBtn.Enabled:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Edit1.SelectAll;
  Edit1.CopyToClipboard;
end;

end.
